/* Labyrint                                    */

// <space>      - svobodno
// <@>          - vhod
// <#>          - vihod
// <other char> - stena

#include <stdio.h>
#include <conio.h>
#include <stdlib.h>
#include <string.h>

#define MAXX 16
#define MAXY 33

char lab[MAXX][MAXY+1];
int  map[MAXX][MAXY];

void input_lab() // Vvod labirinta
  {
  for (int i = 0; i < MAXX; i++) gets(lab[i]);
  }

void output_lab()//vivod labirinta
  {
  for (int i = 0; i < MAXX; i++)
	{
	lab[i][MAXY] = 0;
	puts(lab[i]);
	}
  }

void go(int x, int y, int count)//rasstavlyaem shagi v 4 storoni esli mojno
  {
  map[x][y] = count;

  if ((lab[x+1][y] == ' ')
	 && (x < MAXX)
	 && (map[x+1][y] > count)) go(x+1,y,count+1);

  if ((lab[x][y+1] == ' ')
	 && (y < MAXY)
	 && (map[x][y+1] > count)) go(x,y+1,count+1);

  if ((lab[x-1][y] == ' ')
	 && (x > 0)
	 && (map[x-1][y] > count)) go(x-1,y,count+1);

  if ((lab[x][y-1] == ' ')
	 && (y > 0)
	 && (map[x][y-1] > count)) go(x,y-1,count+1);
  }

void gohome(int x, int y)
  {
  if ((lab[x][y] != '@')
	 && (lab[x][y] != '#')) lab[x][y] = '';

  if (((map[x+1][y] == map[x][y]-1)
	   || ((map[x][y] == 32000) && (map[x+1][y] < 32000)))
	   && (x < MAXX)) gohome(x+1,y);

  if (((map[x][y+1] == map[x][y]-1)
	   || ((map[x][y] == 32000) && (map[x][y+1] < 32000)))
	   && (y < MAXY)) gohome(x,y+1);

  if (((map[x-1][y] == map[x][y]-1)
	   || ((map[x][y] == 32000) && (map[x-1][y] < 32000)))
	   && (x > 0)) gohome(x-1,y);

  if (((map[x][y-1] == map[x][y]-1)
	   || ((map[x][y] == 32000) && (map[x][y-1] < 32000)))
	   && (y > 0)) gohome(x,y-1);
  }

void main(int argc, char *argv[])
  {
  if (argc>1)
	{
	if (freopen(argv[1], "r", stdin) == NULL)
	  {
	  fprintf(stderr,"訡  䠩 %s\n",argv[1]);
		  exit(1);
	  }
	if (argc>2)
	  {
	  if (!strcmp(argv[1],argv[2]))
	{
	fprintf(stderr," 䠩 ᮢ\n");
	exit(3);
	}
	  if (freopen(argv[2], "w", stdout) == NULL)
	{
	fprintf(stderr,"訡  䠩 %s\n",argv[2]);
	exit(2);
	}
	  }
	}
//zapolnyaem chislom ves lab chtob opredelit kraya labirinta
  for (int i = 0; i < MAXX; i++)
	for (int j = 0; j < MAXY; j++) map[i][j] = 32000;

  input_lab();//zagrujaem labirint
  int j;
  //rasstavlyaem cifri iz vhodov
  for (i = 0; i < MAXX; i++)
	for (j = 0; j < MAXY; j++) if (lab[i][j] == '@') go(i,j,0);
//idem iz vihodov do doma
  for (i = 0; i < MAXX; i++)
	for (j = 0; j < MAXY; j++) if (lab[i][j] == '#') gohome(i,j);
//vivodim labirint
  output_lab();

  fclose(stdin);
  fclose(stdout);
  }